import numpy as np
from sklearn.datasets import make_blobs
from sklearn.preprocessing import StandardScaler
from sklearn.neighbors import KNeighborsClassifier
__________________________________________________           #【1】导入train_test_split
from matplotlib import pyplot as plt

#利用sklearn.datasets的make_blobs函数随机生成数量为50的样本数据集
X,Y=make_blobs(n_samples=50,random_state=0,cluster_std=0.6)
_________=train_test_split(X,Y,test_size=0.2,random_state=0) #【2】划分数据集为训练集和测试集
# 标准化数据
std = StandardScaler()
X_train = std.fit_transform(X_train)
X_test = std.transform(X_test)

clf=____________________                                   #【3】创建分类器对象，近邻数为7
clf.fit(X_train,y_train)

score=_________________                                    #【4】基于测试集数据计算模型分类精度
print("模型分类精度评分:",score)

#对[-1,1]预测类别
X_sample=np.array([[-1,1]])
________________________                                   #【5】对X_sample预测类别
#找到X_sample在训练集中的k个近邻
neighbors=clf.kneighbors(X_sample,return_distance=False)
print("点[-1,1]在训练集中的k个近邻:",neighbors)
print("预测值：",Y_sample)
#分类结果可视化，利用直线表示出训练集中与数据点[-1,1]距离最近的k个点
plt.rcParams['font.sans-serif'] = ['SimHei']
plt.rcParams["axes.unicode_minus"]=False
plt.title("训练集中与[-1,1]距离最近的K个点图示")
plt.scatter(X_train[:,0],X_train[:,1],c=y_train,s=100)
plt.scatter(X_sample[:,0],X_sample[:,1],marker="x",c="red",s=100)
for i in neighbors[0]:
    plt.plot([X_train[i][0],X_sample[0][0]],[X_train[i][1],X_sample[0][1]],"k--",linewidth=0.6)
plt.show()

